Type NeuronType = Record
       ID : Integer;

       Power : Integer;
       Pro : Integer;
       Ang : Real;
       Dir : ShortInt;

       Score : LongInt;
       Status : Byte;
     End;

Const MaxNeur = 4;

Var Neuron : Array[1..MaxNeur] of NeuronType;
    ActNeur : Integer;
    ActID : Integer;

Function N_FindNeur(ID : Integer) : Integer;
Var I : Integer;
Begin
  For I := 1 to MaxNeur do
    if Neuron[I].ID = ID Then
    Begin
      N_FindNeur := I;
      Exit;
    End;
  N_FindNeur := -1;
End;
Procedure N_GenerateRandom(I : Integer);
Begin
  If I = -1 Then Exit;
  Inc(ActID);
  Neuron[I].ID := ActID;
  Neuron[I].Power := random(MaxPower);
  Neuron[I].Pro := 1;
  Neuron[I].Ang := Random(Trunc(PI*1000))/1000.0 + PI/2;
  Neuron[I].Dir := 1;
  if Random(2) = 0 Then
    Neuron[I].Dir := -1;
  Neuron[I].Score := 0;
  Neuron[I].Status := 0; {armed}
End;
Procedure N_SortNeurs;
Var I, J : Integer;
    Tmp  : NeuronType;
Begin
  For I := 1 to MaxNeur do
    For J := I + 1 to MaxNeur do
    Begin
      if Neuron[I].Score < Neuron[J].Score Then
      Begin
        Move(Neuron[I], Tmp, sizeof(NeuronType));
        Move(Neuron[J], Neuron[I], sizeof(NeuronType));
        Move(Tmp, Neuron[J], sizeof(NeuronType));
      End;
    End;
End;
Procedure N_CopyNeur(T, F : Integer);
Begin
  Move(Neuron[F], Neuron[T], sizeof(NeuronType));
  Inc(ActID);
  Neuron[T].ID := ActID;
End;
Procedure N_RadioActive(I : Integer);
Begin
  Inc(ActID);
  Neuron[I].ID := ActID;

  Neuron[I].Power := Neuron[I].Power + random(MaxPower div 2)-MaxPower div 4;

  if Neuron[I].Power < 0 Then Neuron[I].Power := 0;
  if Neuron[I].Power > MaxPower Then Neuron[I].Power := MaxPower;

  (*
  Neuron[I].Ang := Neuron[I].Ang {+
                   Trunc(random(Trunc(PI*100/4))-PI*100/8)};


  If Neuron[I].Ang-PI/2 > PI Then Neuron[I].Ang := PI+PI/2;
  If Neuron[I].Ang-PI/2 < 0 Then Neuron[I].Ang := PI/2;
  *)
  Neuron[I].Score := 0;
  Neuron[I].Status := 0; {armed}
End;

Procedure NeurReset;
Var I : Integer;
Begin
  ActID := 0;
  ActNeur := 0;
  For I := 1 to MaxNeur do
    N_GenerateRandom(I);
End;
Procedure NeurAction(WNum : Integer; Var Power, Pro : Integer; var Ang : Real; Var Dir, ID : Integer);
Var I : Integer;
Begin
  Inc(ActNeur);
  If ActNeur > MaxNeur Then
  Begin
    N_SortNeurs;
    N_CopyNeur(2, 1);
    N_Radioactive(2);
    N_GenerateRandom(3);
    N_GenerateRandom(4);
    ActNeur := 1;
  End;

    Neuron[ActNeur].Status := 1; {released}
    Power := Neuron[ActNeur].Power;
    Pro :=   Neuron[ActNeur].Pro;
    Ang :=   Neuron[ActNeur].Ang;
    Dir :=   Neuron[ActNeur].Dir;
    ID  :=   Neuron[ActNeur].ID;
    {generate new neuron}
End;

Procedure NeurDone(ID : Integer; eX, eY, wX, wY, Bad : Integer);
Var I : Integer;
Begin {ohodnot neuron podla uspesnosti}
  I := N_FindNeur(ID);
  If I = -1 Then Exit;
  if Bad = 1 Then
  Begin
    Neuron[I].Score := -10;
    Neuron[I].Status := 2;
    Exit;
  End;
  if (Abs(eX-wX) < 200) And (Abs(eY-wY) < 150) Then
  Begin
    Neuron[I].Score := (eX-wX)*(eX-wX)+(eY-wY)*(eY-wY);
  End Else Neuron[I].Score := 0;
  Neuron[I].Status := 2; {done}
End;

Procedure NeurSelfAttack(ID : Integer);
Var I : Integer;
Begin
  I := N_FindNeur(ID);
  N_GenerateRandom(I);
End;

Procedure MyNeurDone(F, Who : Integer);
Var I, Bad : Integer;
Begin
  If Fire[F].ID = -1 Then EXIT;
  I := N_FindNeur(Fire[F].ID);
  if I = -1 Then EXIT;
  Bad := 0;
  if Who <> -1 Then
    if Worm[Who].Player = 2 Then Bad := 1;
  NeurDone(Fire[F].ID, Trunc(Fire[F].X), Trunc(Fire[F].Y),
           Worm[1]._X, Worm[1]._Y, Bad);
End;{userproc}

{public:

        Procedure NeurReset;
        Procedure NeurAction(WNum : Integer; Var Power, Pro, Ang, Dir, ID : Integer);
        Procedure NeurDone(ID : Integer; eX, eY, wX, wY : Integer);

}